/*
 * Copyright (c) 2012, 2018 Oracle and/or its affiliates. All rights reserved.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0, which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * This Source Code may also be made available under the following Secondary
 * Licenses when the conditions for such availability set forth in the
 * Eclipse Public License v. 2.0 are satisfied: GNU General Public License,
 * version 2 with the GNU Classpath Exception, which is available at
 * https://www.gnu.org/software/classpath/license.html.
 *
 * SPDX-License-Identifier: EPL-2.0 OR GPL-2.0 WITH Classpath-exception-2.0
 */

package com.sun.ts.tests.jaxrs.spec.provider.visibility;

import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import javax.ws.rs.ext.ContextResolver;
import javax.ws.rs.ext.Providers;

@Path("resource")
public class Resource {

  @Path("contextresolver")
  @GET
  public Response contextresolver(@Context Providers providers) {
    ContextResolver<HolderClass> holder = providers
        .getContextResolver(HolderClass.class, MediaType.WILDCARD_TYPE);
    return holder.getContext(HolderClass.class).toResponse();
  }

  @Path("exceptionmapper")
  @GET
  public String exceptionMapper() {
    throw new VisibilityException();
  }

  @Path("bodywriter")
  @GET
  public DummyClass bodyWriter() {
    return new DummyClass();
  }

  @Path("bodyreader")
  @POST
  public String bodyWriter(String text) {
    return text;
  }

}
